.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000	; 1000000 would be a typical value

.data?
align 16
Dest	db 8000 dup(?)

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	REPEAT 2
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke RtlZeroMemory, offset Dest, 8000
		counter_end
		print str$(eax), 9, "cycles for RtlZeroMemory", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		    mov eax, offset Dest
		    mov ecx, 1000
		    mov ebx,20202020h ; change filling ebx to one command
		@@:
		    mov [eax], ebx
		    mov [eax+4], ebx
		    add eax, 8
		    dec ecx
		    jnz @B
		counter_end
		print str$(eax), 9, "cycles for FrkTons", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push edi
			mov ecx, 2000
			mov edi, offset Dest
			mov eax, 20202020h
			rep stosd
			pop edi
		counter_end
		print str$(eax), 9, "cycles for rep stosd", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, offset Dest
			lea ecx, [edx+8000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movdqa [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end
		print str$(eax), 9, "cycles for movdqa", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			mov edx, offset Dest
			lea ecx, [edx+8000]
			mov eax, 20202020h
			movd xmm0, eax
			pshufd xmm0, xmm0, 0
		@@:
			movaps [edx], xmm0
			add edx, 16
			cmp edx, ecx
			jl @B
		counter_end
		print str$(eax), 9, "cycles for movaps", 13, 10, 10
	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]